Index: /branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.cs
===================================================================
--- /branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.cs	(revision 140)
+++ /branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.cs	(revision 141)
@@ -116,5 +116,4 @@
         availableNode.ImageIndex = 0;
         availablePlugins.Nodes.Add(availableNode);
-
       });
       upgrades.ForEach(delegate(PluginDescription upgrade) {
@@ -136,4 +135,5 @@
         currentPlugin.PluginDescription = overridingPlugin;
       });
+      toolStripStatusLabel.Text = "Installed: " + installedPlugins.Nodes.Count + " Updates: " + upgrades.Count + " Available: " + availablePlugins.Nodes.Count;
       RebuildActionHulls();
       pluginTreeView.Sort();
@@ -238,6 +238,4 @@
       dialog.Show();
       worker.RunWorkerAsync();
-
-      // NOTE: ignore version conflicts
     }
 
Index: /branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.designer.cs
===================================================================
--- /branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.designer.cs	(revision 140)
+++ /branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.designer.cs	(revision 141)
@@ -75,4 +75,6 @@
       this.deleteMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.publishMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.statusStrip1 = new System.Windows.Forms.StatusStrip();
+      this.toolStripStatusLabel = new System.Windows.Forms.ToolStripStatusLabel();
       this.menuStrip.SuspendLayout();
       this.splitContainer.Panel1.SuspendLayout();
@@ -81,4 +83,5 @@
       this.toolStrip.SuspendLayout();
       this.pluginContextMenuStrip.SuspendLayout();
+      this.statusStrip1.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -112,5 +115,5 @@
       // 
       this.managePluginSourcesToolStripMenuItem.Name = "managePluginSourcesToolStripMenuItem";
-      this.managePluginSourcesToolStripMenuItem.Size = new System.Drawing.Size(214, 22);
+      this.managePluginSourcesToolStripMenuItem.Size = new System.Drawing.Size(195, 22);
       this.managePluginSourcesToolStripMenuItem.Text = "Edit plugin sources...";
       this.managePluginSourcesToolStripMenuItem.Click += new System.EventHandler(this.managePluginSourcesToolStripMenuItem_Click);
@@ -119,5 +122,5 @@
       // 
       this.installPluginFromFileToolStripMenuItem.Name = "installPluginFromFileToolStripMenuItem";
-      this.installPluginFromFileToolStripMenuItem.Size = new System.Drawing.Size(214, 22);
+      this.installPluginFromFileToolStripMenuItem.Size = new System.Drawing.Size(195, 22);
       this.installPluginFromFileToolStripMenuItem.Text = "Install plugin from file...";
       this.installPluginFromFileToolStripMenuItem.Click += new System.EventHandler(this.installPluginFromFileToolStripMenuItem_Click);
@@ -126,10 +129,10 @@
       // 
       this.toolStripSeparator2.Name = "toolStripSeparator2";
-      this.toolStripSeparator2.Size = new System.Drawing.Size(211, 6);
+      this.toolStripSeparator2.Size = new System.Drawing.Size(192, 6);
       // 
       // installedPluginsToolStripMenuItem
       // 
       this.installedPluginsToolStripMenuItem.Name = "installedPluginsToolStripMenuItem";
-      this.installedPluginsToolStripMenuItem.Size = new System.Drawing.Size(214, 22);
+      this.installedPluginsToolStripMenuItem.Size = new System.Drawing.Size(195, 22);
       this.installedPluginsToolStripMenuItem.Text = "Update";
       this.installedPluginsToolStripMenuItem.Click += new System.EventHandler(this.updateButton_Click);
@@ -138,5 +141,5 @@
       // 
       this.installNewPluginsToolStripMenuItem.Name = "installNewPluginsToolStripMenuItem";
-      this.installNewPluginsToolStripMenuItem.Size = new System.Drawing.Size(206, 22);
+      this.installNewPluginsToolStripMenuItem.Size = new System.Drawing.Size(195, 22);
       this.installNewPluginsToolStripMenuItem.Text = "Delete/Upgrade/Install...";
       this.installNewPluginsToolStripMenuItem.Click += new System.EventHandler(this.upgradeButton_Click);
@@ -145,10 +148,10 @@
       // 
       this.toolStripSeparator3.Name = "toolStripSeparator3";
-      this.toolStripSeparator3.Size = new System.Drawing.Size(211, 6);
+      this.toolStripSeparator3.Size = new System.Drawing.Size(192, 6);
       // 
       // refreshPluginListToolStripMenuItem
       // 
       this.refreshPluginListToolStripMenuItem.Name = "refreshPluginListToolStripMenuItem";
-      this.refreshPluginListToolStripMenuItem.Size = new System.Drawing.Size(214, 22);
+      this.refreshPluginListToolStripMenuItem.Size = new System.Drawing.Size(195, 22);
       this.refreshPluginListToolStripMenuItem.Text = "Refresh plugin list";
       this.refreshPluginListToolStripMenuItem.Click += new System.EventHandler(this.refreshPluginListToolStripMenuItem_Click);
@@ -157,5 +160,5 @@
       // 
       this.exitToolStripMenuItem.Name = "exitToolStripMenuItem";
-      this.exitToolStripMenuItem.Size = new System.Drawing.Size(214, 22);
+      this.exitToolStripMenuItem.Size = new System.Drawing.Size(195, 22);
       this.exitToolStripMenuItem.Text = "Close";
       this.exitToolStripMenuItem.Click += new System.EventHandler(this.closeToolStripMenuItem_Click);
@@ -172,5 +175,5 @@
       // 
       this.aboutToolStripMenuItem.Name = "aboutToolStripMenuItem";
-      this.aboutToolStripMenuItem.Size = new System.Drawing.Size(126, 22);
+      this.aboutToolStripMenuItem.Size = new System.Drawing.Size(115, 22);
       this.aboutToolStripMenuItem.Text = "About...";
       this.aboutToolStripMenuItem.Click += new System.EventHandler(this.aboutToolStripMenuItem_Click);
@@ -314,10 +317,10 @@
             this.publishMenuItem});
       this.pluginContextMenuStrip.Name = "pluginContextMenuStrip";
-      this.pluginContextMenuStrip.Size = new System.Drawing.Size(119, 70);
+      this.pluginContextMenuStrip.Size = new System.Drawing.Size(108, 70);
       // 
       // installMenuItem
       // 
       this.installMenuItem.Name = "installMenuItem";
-      this.installMenuItem.Size = new System.Drawing.Size(152, 22);
+      this.installMenuItem.Size = new System.Drawing.Size(107, 22);
       this.installMenuItem.Text = "Install";
       this.installMenuItem.Click += new System.EventHandler(this.installButton_Clicked);
@@ -326,5 +329,5 @@
       // 
       this.deleteMenuItem.Name = "deleteMenuItem";
-      this.deleteMenuItem.Size = new System.Drawing.Size(118, 22);
+      this.deleteMenuItem.Size = new System.Drawing.Size(107, 22);
       this.deleteMenuItem.Text = "Delete";
       this.deleteMenuItem.Click += new System.EventHandler(this.removeButton_Clicked);
@@ -333,7 +336,23 @@
       // 
       this.publishMenuItem.Name = "publishMenuItem";
-      this.publishMenuItem.Size = new System.Drawing.Size(152, 22);
+      this.publishMenuItem.Size = new System.Drawing.Size(107, 22);
       this.publishMenuItem.Text = "Publish";
       this.publishMenuItem.Click += new System.EventHandler(this.publishButton_Click);
+      // 
+      // statusStrip1
+      // 
+      this.statusStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.toolStripStatusLabel});
+      this.statusStrip1.Location = new System.Drawing.Point(0, 515);
+      this.statusStrip1.Name = "statusStrip1";
+      this.statusStrip1.Size = new System.Drawing.Size(828, 22);
+      this.statusStrip1.TabIndex = 3;
+      this.statusStrip1.Text = "statusStrip1";
+      // 
+      // toolStripStatusLabel
+      // 
+      this.toolStripStatusLabel.Name = "toolStripStatusLabel";
+      this.toolStripStatusLabel.Size = new System.Drawing.Size(103, 17);
+      this.toolStripStatusLabel.Text = "toolStripStatusLabel";
       // 
       // ManagerForm
@@ -342,4 +361,5 @@
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.ClientSize = new System.Drawing.Size(828, 537);
+      this.Controls.Add(this.statusStrip1);
       this.Controls.Add(this.toolStrip);
       this.Controls.Add(this.splitContainer);
@@ -357,4 +377,6 @@
       this.toolStrip.PerformLayout();
       this.pluginContextMenuStrip.ResumeLayout(false);
+      this.statusStrip1.ResumeLayout(false);
+      this.statusStrip1.PerformLayout();
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -392,4 +414,6 @@
     private System.Windows.Forms.ToolStripSeparator toolStripSeparator3;
     private System.Windows.Forms.ImageList pluginIcons;
+    private System.Windows.Forms.StatusStrip statusStrip1;
+    private System.Windows.Forms.ToolStripStatusLabel toolStripStatusLabel;
   }
 }
Index: /branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.resx
===================================================================
--- /branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.resx	(revision 140)
+++ /branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.resx	(revision 141)
@@ -290,4 +290,7 @@
     <value>212, 17</value>
   </metadata>
+  <metadata name="statusStrip1.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>490, 17</value>
+  </metadata>
   <data name="$this.Icon" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
     <value>